export interface Experiment {
    id: string;
    percentage: number;
    variations: Array<Variation>;
    audience?: Record<string, any>;
}
export interface Variation {
    id: string;
    percentage: number;
}
export interface Feature {
    id: string;
    percentage: number;
    data?: Record<string, any>;
    audience?: Record<string, any>;
}
export interface Allocation {
    id: string;
    rangeEnd: number;
}
export interface Datafile {
    experiments?: {
        [id: string]: Experiment;
    };
    features?: {
        [id: string]: Feature;
    };
}
declare class Config {
    private datafile;
    private maxBuckets;
    constructor(datafile: Datafile, maxBuckets: number);
    private computeRangeEnd;
    getExperiments(): {
        [id: string]: Experiment;
    };
    getExperiment(id: string): Experiment;
    getFeatures(): {
        [id: string]: Feature;
    };
    getFeature(id: string): Feature;
    getFeatureAllocation(id: string): Allocation | undefined;
    getExperimentAllocation(id: string): Allocation | undefined;
    getExperimentAllocations(id: string): Array<Allocation>;
}
export default Config;
