import { Datafile, Feature } from './Config';
import Storage from './Storage';
declare class Engine {
    static readonly TOTAL_BUCKETS = 10000;
    static readonly TRAFFIC_ALLOCATION_SALT = "tas";
    private config;
    private bucketer;
    private evaluator;
    private userId?;
    private attributes?;
    private storage?;
    private cache;
    constructor({ datafile, userId, attributes, storage }: {
        datafile: Datafile;
        storage?: Storage<string>;
        userId?: string;
        attributes?: Record<string, any>;
    });
    private computeKey;
    private getForcedVariation;
    getUserId(): string | undefined;
    getAttributes(): Record<string, any> | undefined;
    setUserId(userId: string): void;
    setAttributes(attributes?: Record<string, any>): void;
    setForcedVariation(experimentId: string, variationId: string): void;
    isFeatureEnabled(featureId: string, userId?: string, attributes?: Record<string, any>): boolean | null;
    getFeature(featureId: string): Feature;
    getEnabledFeatures(userId?: string, attributes?: Record<string, any>): {
        [featureId: string]: boolean;
    };
    getVariationId(experimentId: string, userId?: string, attributes?: Record<string, any>): string | null;
    getVariationIds(userId?: string, attributes?: Record<string, any>): {
        [experimentId: string]: string;
    };
}
export default Engine;
